

#include "resource_texture.h"



ResourceTexture::ResourceTexture(const std::string& imageName, GLenum target)
    : Resource(&ResourceTexture::type)
{
  Resource::Pointer* ptr = this->acquireResource(imageName + ',' + "TEST");

  if (ptr)
    this->acquireData(static_cast<ResourceTexture::TextureResourcePointer*>(ptr)->ptr());
  else
  {
    std::string fileName = this->Resource::locateFile(imageName);
    this->Texture::loadImage(fileName, target);
    this->Resource::addResource(new ResourceTexture::TextureResourcePointer(imageName + ',' + "TEST", KeepLevel(), this->Texture::dataPointer()));
  }
}


Resource::Type ResourceTexture::type(Texture::staticClassID());





ResourceTexture::TextureResourcePointer::TextureResourcePointer(const std::string& loadString, const Resource::KeepLevel& keepLevel, const TextureData::Pointer& data)
    : Resource::Pointer(loadString, keepLevel) , pointer(data)
{}


